osl::ImmediateCheckmate Class Reference

`#include <immediateCheckmate.h>`

## Static Public Member Functions

template<Player P, bool setBestMove>
static bool | slowHasCheckmateMoveDirPiece (NumEffectState const &state, Square target, King8Info mask, Direction d, Square pos, Piece p, Ptype ptype, Move &bestMove)
template<Player P, bool setBestMove>
static bool | hasCheckmateMoveDirPiece (NumEffectState const &state, Square target, King8Info mask, Direction d, Square pos, Piece p, Move &bestMove)
template<Player P, bool setBestMove>
static bool | hasCheckmateMoveDir (NumEffectState const &state, Square target, King8Info mask, Direction d, Move &bestMove)
template<Player P, bool setBestMove>
static bool | hasCheckmateMove (NumEffectState const &state, Square target, King8Info mask, Move &bestMove)
template<Player P>
static bool | hasCheckmateMove (NumEffectState const &state)
| 一手詰めがある局面かどうか判定(move).
template<Player P>
static bool | hasCheckmateMove (NumEffectState const &state, King8Info)
template<Player P>
static bool | hasCheckmateMove (NumEffectState const &state, Move &bestMove)
| 一手詰めがある局面かどうか判定(move).
template<Player P>
static bool | hasCheckmateMove (NumEffectState const &state, King8Info canMoveMask, Square king, Move &bestMove)
static bool | hasCheckmateMove (Player pl, NumEffectState const &state)
static bool | hasCheckmateMove (Player pl, NumEffectState const &state, Move &bestMove)

## Static Private Member Functions

template<Player P, bool setBestMove>
static bool | hasCheckmateDrop (NumEffectState const &state, Square target, King8Info mask, Move &bestMove)

## Detailed Description

Definition at line 11 of file immediateCheckmate.h.

## Member Function Documentation

## hasCheckmateDrop()

template<Player P, bool setBestMove>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateDrop | ( | NumEffectState const & | state,
|  | Square | target,
|  | King8Info | mask,
|  | Move & | bestMove )

static private

## hasCheckmateMove() [1/7]

template<Player P>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | NumEffectState const & | state | ) |

static

一手詰めがある局面かどうか判定(move).

手番の側に王手がかかっている場合は除く 長い利きによる王手は生成しない． pinされている駒の利きがないために詰みになる例も扱わない．

Parameters

  P(template) | - 攻撃側(手番側)のプレイヤー
  state | - 局面

## hasCheckmateMove() [2/7]

template<Player P>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | NumEffectState const & | state,
|  | King8Info | canMoveMask,
|  | Square | king,
|  | Move & | bestMove )

static

## hasCheckmateMove() [3/7]

template<Player P>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | NumEffectState const & | state,
|  | King8Info | )

static

## hasCheckmateMove() [4/7]

template<Player P>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | NumEffectState const & | state,
|  | Move & | bestMove )

static

一手詰めがある局面かどうか判定(move).

手番の側に王手がかかっている場合は除く 長い利きによる王手は生成しない． pinされている駒の利きがないために詰みになる例も扱わない．

Parameters

  P(template) | - 攻撃側(手番側)のプレイヤー
  state | - 局面
  best_move | - ある場合に詰めの手を返す

## hasCheckmateMove() [5/7]

template<Player P, bool setBestMove>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | NumEffectState const & | state,
|  | Square | target,
|  | King8Info | mask,
|  | Move & | bestMove )

static

Referenced by osl::rating::BradleyTerry::accumulate(), and osl::rating::Threatmate::Helper::operator()().

## hasCheckmateMove() [6/7]

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | Player | pl,
|  | NumEffectState const & | state )

static

Definition at line 33 of file immediateCheckmate.cc.

## hasCheckmateMove() [7/7]

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMove | ( | Player | pl,
|  | NumEffectState const & | state,
|  | Move & | bestMove )

static

Definition at line 42 of file immediateCheckmate.cc.

## hasCheckmateMoveDir()

template<Player P, bool setBestMove>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMoveDir | ( | NumEffectState const & | state,
|  | Square | target,
|  | King8Info | mask,
|  | Direction | d,
|  | Move & | bestMove )

static

## hasCheckmateMoveDirPiece()

template<Player P, bool setBestMove>

bool osl::checkmate::ImmediateCheckmate::hasCheckmateMoveDirPiece | ( | NumEffectState const & | state,
|  | Square | target,
|  | King8Info | mask,
|  | Direction | d,
|  | Square | pos,
|  | Piece | p,
|  | Move & | bestMove )

static

## slowHasCheckmateMoveDirPiece()

template<Player P, bool setBestMove>

bool osl::checkmate::ImmediateCheckmate::slowHasCheckmateMoveDirPiece | ( | NumEffectState const & | state,
|  | Square | target,
|  | King8Info | mask,
|  | Direction | d,
|  | Square | pos,
|  | Piece | p,
|  | Ptype | ptype,
|  | Move & | bestMove )

static

The documentation for this class was generated from the following files:

- immediateCheckmate.h
- immediateCheckmate.cc